#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_Constant_1" type="Constant" x="100" y="100">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="280" y="100">
      <Parameter name="TYPE" type="int" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="490" y="100">
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="INPUT"/>
    <NetOutput name="TEXT" node="node_MAIN_LOOP_1" terminal="TEXT" object_type="any" description="Dynamic"/>
    <NetOutput name="ONSET_OUTPUT" node="node_MAIN_LOOP_1" terminal="ONSET_OUTPUT" object_type="any" description="Dynamic"/>
    <NetOutput name="STMP_OUTPUT" node="node_MAIN_LOOP_1" terminal="STMP_OUTPUT" object_type="any" description="Dynamic"/>
    <NetOutput name="CHROMA_OUTPUT" node="node_MAIN_LOOP_1" terminal="CHROMA_OUTPUT" object_type="any" description="Dynamic"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="390" y="130">
      <Parameter name="LENGTH" type="int" value="512" description="FFT length in sample. [default: 512]"/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: CONJ]"/>
      <Parameter name="WINDOW_LENGTH" type="int" value="512" description="Window length of the window function. [default: 512]"/>
    </Node>
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="100" y="170">
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_BeatTracker_1" type="BeatTracker" x="580" y="170">
      <Parameter name="RELIABILITY-THRESHOLD" type="float" value="0.1" description="The threshold for the beat detection."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="sampling rate of sound data."/>
      <Parameter name="MAX_BPM" type="int" value="140" description="Maximum BPM."/>
      <Parameter name="MIN_BPM" type="int" value="60" description="Minimum BPM."/>
      <Parameter name="VECTOR_FLAG" type="bool" value="true" description="Output vectors or not."/>
      <Parameter name="LOG_FLAG" type="bool" value="true" description="Log or not."/>
    </Node>
    <Node name="node_SaveVectorFrames_1" type="SaveVectorFrames" x="900" y="240">
      <Parameter name="FILENAME" type="string" value="onset_" description="The file name for saving vector data."/>
      <Parameter name="OUTPUTTYPE" type="string" value="TEXT" description="Output file format type [default: TEXT]"/>
      <Parameter name="TEXTFORMAT" type="string" value="SCIENTIFIC" description="Output file format type [default: FIXED]"/>
    </Node>
    <Node name="node_SaveVectorFrames_2" type="SaveVectorFrames" x="900" y="320">
      <Parameter name="FILENAME" type="string" value="stmp_" description="The file name for saving vector data."/>
      <Parameter name="OUTPUTTYPE" type="string" value="TEXT" description="Output file format type [default: TEXT]"/>
      <Parameter name="TEXTFORMAT" type="string" value="SCIENTIFIC" description="Output file format type [default: FIXED]"/>
    </Node>
    <Node name="node_SaveVectorFrames_3" type="SaveVectorFrames" x="900" y="400">
      <Parameter name="FILENAME" type="string" value="chroma_" description="The file name for saving vector data."/>
      <Parameter name="OUTPUTTYPE" type="string" value="TEXT" description="Output file format type [default: TEXT]"/>
      <Parameter name="TEXTFORMAT" type="string" value="SCIENTIFIC" description="Output file format type [default: FIXED]"/>
    </Node>
    <Node name="node_TextConverter_1" type="TextConverter" x="900" y="100">
      <Parameter name="ENABLE_DEBUG" type="bool" value="true" description="Enable debug print. The same text as output from OUTPUT is printed with standard output."/>
    </Node>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_BeatTracker_1" input="AUDIO"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_BeatTracker_1" input="FFTAUDIO"/>
    <Link from="node_BeatTracker_1" output="ONSET_VECTOR" to="node_SaveVectorFrames_1" input="INPUT"/>
    <Link from="node_BeatTracker_1" output="STPM_VECTOR" to="node_SaveVectorFrames_2" input="INPUT"/>
    <Link from="node_BeatTracker_1" output="CHROMA_VECTOR" to="node_SaveVectorFrames_3" input="INPUT"/>
    <Link from="node_BeatTracker_1" output="BEAT_DETECTED" to="node_TextConverter_1" input="DETECT"/>
    <Link from="node_BeatTracker_1" output="TEMPO" to="node_TextConverter_1" input="TEMPO"/>
    <Link from="node_BeatTracker_1" output="CONFIDENCE" to="node_TextConverter_1" input="CONFIDENCE"/>
    <NetInput name="INPUT" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetOutput name="TEXT" node="node_TextConverter_1" terminal="TEXT" object_type="string" description="Outputs JSON formatted text based on input. Multiple inputs are automatically parsed. One JSON text is output per frame."/>
    <NetOutput name="ONSET_OUTPUT" node="node_SaveVectorFrames_1" terminal="OUTPUT" object_type="any" description="The same as input."/>
    <NetOutput name="STMP_OUTPUT" node="node_SaveVectorFrames_2" terminal="OUTPUT" object_type="any" description="The same as input."/>
    <NetOutput name="CHROMA_OUTPUT" node="node_SaveVectorFrames_3" terminal="OUTPUT" object_type="any" description="The same as input."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
  </Network>
</Document>
